# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..13\n"; }
END {print "not ok 1\n" unless $loaded;}
use DFA::Set::Memory;
$loaded = 1;
print "ok 1\n";

use strict;
######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

my $OK=2;

## create state machine
my $dfa=DFA::Set::Memory->new(
        States=>{
            Foo=>[qw(Biff)],
            Biff=>[qw(Foo Bob)],
            Bob=>[],
        }, 
        Terminal=>'Bob');

print "not " unless $dfa;
print "ok $OK\n"; $OK++;

## add some objects
my $o1={n=>1};
my $o2={n=>2};

$dfa->add('o1', $o1, 'Foo');
$dfa->add('o2', $o2, 'Foo');

## did this stick?
my $s1=$dfa->find_state('o1');
print "not " unless $s1 eq 'Foo';
print "ok $OK\n"; $OK++;

## move one of the tokens
$dfa->transition(o2=>'Biff');

## did this stick?
my $s2=$dfa->find_state('o2');
print "not " unless $s2 eq 'Biff';
print "ok $OK\n"; $OK++;

## did it affect other token?
$s1=$dfa->find_state('o1');
print "not " unless $s1 eq 'Foo';
print "ok $OK\n"; $OK++;

## move to Terminal
print "not " unless $dfa->transition(o2=>'Bob');
print "ok $OK\n"; $OK++;

## find o1
my $t=$dfa->find_payload('o1');
print "not " unless $t and $t->{n}==1;
print "ok $OK\n"; $OK++;

## remove o2
$dfa->remove('o2');

## did it stick?
$t=$dfa->find_payload('o2');
print "not " if $t;
print "ok $OK\n"; $OK++;

## did it affect o1?
$t=$dfa->find_payload('o1');
print "not " unless $t and $t->{n}==1;
print "ok $OK\n"; $OK++;



## check illegal transition
print "not " if eval {
    $dfa->transition(o1=>'Bob');
    return 1;
};
print "ok $OK\n"; $OK++;

## illegal add
print "not " if eval {
    $dfa->add(o2=>$o2, 'Zipple');
    return 1;
};
print "ok $OK\n"; $OK++;

## illegal remove
print "not " if eval {
    $dfa->remove('o2');
    $dfa->remove('o2');     # 2nd time should die
    return 1;
};
print "ok $OK\n"; $OK++;


$dfa->add(o2=>$o2, 'Foo');


my @os=$dfa->list('Foo');
unless(@os==2) {
    print "not ";
} 
else {

    $os[0]=$dfa->find_payload($os[0]);
    $os[1]=$dfa->find_payload($os[1]);
    if($os[0]->{n}+$os[1]->{n} != 3) {
        print "not ";
    }
}
print "ok $OK\n"; $OK++;